// VideoAddOn.cpp

#ifndef _VideoAddOn_h
#define _VideoAddOn_h

	#include <MediaFormats.h>
	#include <MediaAddOn.h>
	#include <OS.h>
	
	#include "VideoConsumer.h"
	
	class VideoAddOn
	:
		public BMediaAddOn
	{
	public:
		explicit VideoAddOn( image_id image );
		
		virtual ~VideoAddOn();
		
		status_t InitCheck( const char ** outFailureText );
		
		int32 CountFlavors();
		
		status_t GetFlavorAt( int32 n, const flavor_info ** outInfo );
		
		BMediaNode * InstantiateNodeFor(
			const flavor_info * info,
			BMessage * configuration,
			status_t * outError );
		
		status_t GetConfigurationFor(
			BMediaNode * node,
			BMessage * configuration );
		
		bool WantsAutoStart();
		
		status_t AutoStart(
			int inCount,
			BMediaNode ** outNode,
			int32 * outInternalID,
			bool * outHasMore );
	
	public:
		status_t LoadConfigurationFile();
	
		status_t SaveConfigurationFile();
	
		status_t LoadConfigurationFor( BMediaNode * node );
	
		status_t SaveConfigurationFor( const BMediaNode * node );
	
	public:
	
		static volatile port_id fVideoProducerPort;
		static volatile port_id fVideoConsumerPort;
		
		static const char * kSettingsFileName;
	
	private:
		status_t fStatus;
		int32 fFlavors_count;
		flavor_info fFlavors[1];
		int32 fFormats_count;
		media_format fFormats[10];
	
	#if 1
		BMessage fConfigurations;
	#endif
	
		VideoConsumer * fConsumer;
	};
	
	extern "C" _EXPORT BMediaAddOn * make_media_addon( image_id you );
	
#endif
